=== debian/changelog ===
hugin (2015.0.0+dfsg-1) unstable; urgency=medium

  * Bump version number, rc3 is identical to the release.
  * B-d on libpng-dev instead of libpng12-dev. Closes: #662370

 -- Andreas Metzler <ametzler@debian.org>  Wed, 06 Jan 2016 16:35:49 +0100
