=== debian/tests/control ===
Tests: simple.pano.test
Depends: hugin
Restrictions: allow-stderr
